from enum import Enum

THISPOLICYNAME = ''
def setThisPolicyName(name):
    THISPOLICYNAME = name

def getThisPolicyName():
    return THISPOLICYNAME

DB_NAMING_CONVENTION = {
    "ix": "%(column_0_label)s_idx",
    "uq": "%(table_name)s_%(column_0_name)s_key",
    "ck": "%(table_name)s_%(constraint_name)s_check",
    "fk": "%(table_name)s_%(column_0_name)s_fkey",
    "pk": "%(table_name)s_pkey",
}


class RedisKeyConstants:
    SMS_CODE_KEY = "sms:code:"
    TOKEN_KEY = "Youcailogin:"
    ACCESS_TOKEN_KEY = "applet_access_token_youcai"
    SESSION_KEY = "session_id_youcai:"
    OFFICIAL_ACCESS_TOKEN_KEY = "official_access_token_youcai"


class Environment(str, Enum):
    LOCAL = "LOCAL"
    STAGING = "STAGING"
    TESTING = "TESTING"
    PRODUCTION = "PRODUCTION"

    @property
    def is_debug(self):
        return self in (self.LOCAL, self.STAGING, self.TESTING)

    @property
    def is_testing(self):
        return self == self.TESTING

    @property
    def is_deployed(self) -> bool:
        return self in (self.STAGING, self.PRODUCTION)
