from objectbox.model import Entity, Id, Property, PropertyType


@Entity(id=1, uid=1)
class ObservedData:
    id = Id(id=1, uid=1001)
    key = Property(str, id=2, uid=1002)
    date = Property(str, id=3, uid=1003)
    time_return = Property(float, type=PropertyType.float, id=4, uid=1004)
    cash = Property(float, type=PropertyType.float, id=5, uid=1005)
    benchmark_return = Property(float, type=PropertyType.float, id=6, uid=1006)
    is_running = Property(bool, id=7, uid=1007)
    benchmark_ratio = Property(float, type=PropertyType.float, id=8, uid=1008)
    max_draw_down = Property(float, type=PropertyType.float, id=9, uid=1009)
    strategy_ratio = Property(float, type=PropertyType.float, id=10, uid=1010)



@Entity(id=2, uid=2)
class BackResultIndicator:
    id = Id(id=5, uid=2001)
    key = Property(str, id=6, uid=2002)
    indicator = Property(str, id=7, uid=2003)


@Entity(id=3, uid=3)
class Position:
    id = Id(id=1, uid=3001)
    key = Property(str, id=2, uid=3002)
    date = Property(str, id=3, uid=3003)
    name = Property(str, id=4, uid=3004)
    size = Property(int, id=5, uid=3005)
    price = Property(float, id=6, uid=3006)
    adjbase = Property(float, id=7, uid=3007)
    profit_loss = Property(float, id=8, uid=3008)


@Entity(id=4, uid=4)
class TradeInfo:
    id = Id(id=1, uid=4001)
    key = Property(str, id=2, uid=4002)
    stock_code = Property(str, id=3, uid=4003)
    ordtype = Property(str, id=4, uid=4004)
    executed_size = Property(int, id=5, uid=4005)
    executed_price = Property(float, id=6, uid=4006)
    value = Property(float, id=7, uid=4007)
    size = Property(int, id=8, uid=4008)
    price = Property(float, id=9, uid=4009)
    status = Property(str, id=10, uid=4010)
    pnl = Property(float, id=11, uid=4011)
    date = Property(str, id=13, uid=4013)
    commission = Property(float, id=14, uid=4014)


@Entity(id=5, uid=5)
class TranObserverData:
    id = Id(id=1, uid=5001)
    key = Property(str, id=2, uid=5002)
    date = Property(str, id=3, uid=5003)
    time_return = Property(float, type=PropertyType.float, id=4, uid=5004)
    cumulative_return = Property(float, type=PropertyType.float, id=5, uid=5005)
    trades = Property(float, type=PropertyType.float, id=6, uid=5006)
    total_revenue = Property(float, type=PropertyType.float, id=7, uid=5007)
    current_price = Property(float, type=PropertyType.float, id=8, uid=5008)
    open = Property(float, type=PropertyType.float, id=9, uid=5009)
    close = Property(float, type=PropertyType.float, id=10, uid=50010)
    high = Property(float, type=PropertyType.float, id=11, uid=50011)
    low = Property(float, type=PropertyType.float, id=12, uid=50012)
    volume = Property(float, type=PropertyType.float, id=13, uid=50013)
    cash = Property(float, type=PropertyType.float, id=14, uid=50014)
    annualized_return = Property(float, type=PropertyType.float, id=15, uid=50015)


@Entity(id=6, uid=6)
class TranReturn:
    id = Id(id=1, uid=6001)
    key = Property(str, id=2, uid=6002)
    date = Property(str, id=3, uid=6003)
    time_return = Property(float, type=PropertyType.float, id=4, uid=6004)
    benchmark_return = Property(float, type=PropertyType.float, id=5, uid=6005)
    cumulative_return = Property(float, type=PropertyType.float, id=6, uid=6006)
    max_draw_down = Property(float, type=PropertyType.float, id=7, uid=6007)


@Entity(id=7, uid=7)
class TranOrders:
    id = Id(id=1, uid=7001)
    key = Property(str, id=2, uid=7002)
    order_return = Property(str, id=3, uid=7003)


@Entity(id=8, uid=8)
class TranTradeInfo:
    id = Id(id=1, uid=8001)
    key = Property(str, id=2, uid=8002)
    stock_code = Property(str, id=3, uid=8003)
    ordtype = Property(str, id=4, uid=8004)
    executed_size = Property(int, id=5, uid=8005)
    executed_price = Property(float, id=6, uid=8006)
    value = Property(float, id=7, uid=8007)
    size = Property(int, id=8, uid=8008)
    price = Property(float, id=9, uid=8009)
    status = Property(str, id=10, uid=8010)
    pnl = Property(float, id=11, uid=8011)
    date = Property(str, id=13, uid=8013)
    commission = Property(float, id=14, uid=8014)
    exec_type = Property(str, id=15, uid=8015)
    trail_stop = Property(float, id=16, uid=8016)
    trail_price_limit = Property(float, id=17, uid=8017)


@Entity(id=9, uid=9)
class TranData:
    id = Id(id=1, uid=9001)
    key = Property(str, id=2, uid=9002)
    alpha = Property(float,type=PropertyType.float, id=3,uid=9003)
    beta = Property(float, type=PropertyType.float, id=4,uid=9004)
    sharpe_ratio = Property(float, id=5,uid=9005)
    start_date  = Property(str,id=6, uid=9006)
    close_date = Property(str, id=7, uid=9007)
    use_date = Property(str, id=8, uid=9008)
    filename = Property(str, id=11, uid=1011)
    day_alpha_array = Property(str,id=12,uid=1012)