from tortoise import Model, fields
from src.models import with_table_name
from src.models.strategy import Strategy


class Position(Model):
    id = fields.IntField(pk=True, description="主键")
    key = fields.CharField(max_length=30, description="键")
    date = fields.DateField(description="日期")
    name = fields.CharField(max_length=30, description="名称")
    size = fields.IntField(description="数量")
    price = fields.FloatField(description="价格")
    adjbase = fields.FloatField(description="复权基数")
    profit = fields.FloatField(description="利润")

    class Meta:
        table = with_table_name("position")


def create(id,pk,key, date, name, size, price, adjbase, profit):
    try:
        position = Position(id=id,pk=pk,key=key, date=date, name=name, size=size, price=price, adjbase=adjbase, profit=profit)
        position.save()
        return position
    except Exception as e:
        print(f"Position create error: {str(e)}")
        return None


def bulk_create(param):
    try:
        Position.bulk_create(param)
        return "Position bulk create success"
    except Exception as e:
        print(f"Position bulk create error: {str(e)}")
        return None