from tortoise import Model, fields

from src.models import with_table_name, AccountType, supervisionFee, transferFee, IsType

from tortoise.contrib.pydantic import pydantic_model_creator


class SecurityAccount(Model):
    """
       证券账户
    """
    id = fields.IntField(pk=True, description="主键")
    securities_name = fields.CharField(max_length=30, null=False, description="证券公司名字昵称")

    fund_account = fields.BigIntField(null=True, description="资金账户")


    account_alias = fields.CharField(max_length=30, null=False, description="账户别名")

    money = fields.FloatField(null=True, description="账户金额")
    available_money = fields.FloatField(null=True, description="可用金额")
    available_proportion = fields.FloatField(null=True, description="可用资金占比")
    freeze = fields.FloatField(null=True, description="冻结金额")

    class Meta:
        table = with_table_name("security_account")


SecurityAccountResponse = pydantic_model_creator(
    SecurityAccount
)
