from tortoise import Model, fields

from src.models import with_table_name

from tortoise.contrib.pydantic import pydantic_model_creator


class Snowball(Model):
    """
       雪球相关信息
    """
    id = fields.IntField(pk=True, description="主键")
    snowball_token = fields.CharField(max_length=10000,null=True, description="雪球用户的token")

    class Meta:
        table = with_table_name("snowball")


SnowballResponse = pydantic_model_creator(
    Snowball
)
