from tortoise import Model, fields
from src.models import with_table_name


class Strategy(Model):
    id = fields.IntField(pk=True, description='主键')
    strategy_name = fields.CharField(max_length=255, description='策略名称')
    strategy_hash = fields.CharField(max_length=255, description='策略版本号')
    strategy_type = fields.CharField(max_length=255, null=True, description='策略类型')
    user_id = fields.IntField(null=True, description='所属用户')
    backtest_count = fields.IntField(null=True, description='回测次数')
    backtest_keys = fields.JSONField(null=True, description='回测key列表')
    is_deleted = fields.BooleanField(max_length=255, default=False, description='是否删除')
    created_at = fields.DatetimeField(auto_now_add=True, description="创建时间")
    updated_at = fields.DatetimeField(auto_now=True, description="修改时间")
    deleted_at = fields.DatetimeField(null=True, description="删除时间")

    class Meta:
        table = with_table_name("Strategy")
