from tortoise import Model, fields
from src.models import with_table_name




class Users(Model):
    avatar_url = fields.CharField(max_length=255, null=True, )
    beta_account_type = fields.CharField(max_length=30, null=True, )
    created_at = fields.DatetimeField(auto_now_add=True, )
    created_user_id = fields.IntField()
    dedicated_id = fields.IntField()
    deleted_at = fields.DatetimeField(null=True, )
    id = fields.IntField(pk=True, )
    invitation_code = fields.CharField(max_length=10, null=True, )
    invited_user_id = fields.IntField()
    is_deleted = fields.IntField(index=True, )
    login_at = fields.DatetimeField(null=True, )
    member_type = fields.IntField()
    nickname = fields.CharField(max_length=30, null=True, )
    pre_cost_time = fields.IntField()
    qr_code = fields.CharField(max_length=255, null=True, )
    status = fields.BooleanField(null=True, default=False, )
    updated_at = fields.DatetimeField(auto_now_add=True, )

    class Meta:
        table = with_table_name("users")