from tortoise import Model, fields
from src.models import with_table_name


class WanceDataStock(Model):
    id = fields.IntField(pk=True, )
    stock_name = fields.CharField(max_length=50, null=True, description='股票名称', )
    stock_code = fields.CharField(max_length=50, null=True, description='股票代码', )
    stock_sector = fields.JSONField(null=True, description='股票板块', )
    stock_type = fields.JSONField(null=True, description='股票类型', )
    time_start = fields.CharField(max_length=10, null=True, description='上市时间', )
    time_expire = fields.CharField(max_length=10, null=True, description='退市时间', )
    time_end = fields.CharField(max_length=10, null=True, description='上一次回测结束时间', )
    market_sector = fields.CharField(max_length=20, null=True, description='所属市场', )
    financial_dividend = fields.FloatField(null=True, default=0, description='分红率', )
    financial_ex_gratia = fields.FloatField(null=True, default=0, description='扣非后每股收益', )
    financial_cash_flow = fields.FloatField(null=True, default=0, description='每股现金流', )
    financial_asset_value = fields.FloatField(null=True, default=0, description='每股净资产', )
    financial_reserve_per = fields.FloatField(null=True, default=0, description='每股资本公积金', )
    financial_undistributed_profit = fields.FloatField(null=True, default=0, description='每股未分配利润', )
    profit_asset_value = fields.FloatField(null=True, default=0, description='净资产收益率', )
    profit_sale_ratio = fields.FloatField(null=True, default=0, description='盈利销售净利率', )
    profit_gross_rate = fields.FloatField(null=True, default=0, description='销售毛利率', )
    profit_business_increase = fields.FloatField(null=True, default=0, description='营业收入增长率', )
    profit_dividend_rate = fields.FloatField(null=True, default=0, description='股息率', )
    growth_Income_rate = fields.FloatField(null=True, default=0, description='营业总收入同比增长率', )
    growth_growth_rate = fields.FloatField(null=True, default=0, description='营业利润同比增长率', )
    growth_nonnet_profit = fields.FloatField(null=True, default=0, description='扣非净利润增长率', )
    growth_attributable_rate = fields.FloatField(null=True, default=0, description='归母净利润同比增长率', )
    valuation_PEGTTM_ratio = fields.FloatField(null=True, default=0, description='市盈率TTM', )
    valuation_PEG_percentile = fields.FloatField(null=True, default=0, description='市盈率百分位', )
    valuation_PB_TTM = fields.FloatField(null=True, default=0, description='市净率TTM', )
    valuation_PB_percentile = fields.FloatField(null=True, default=0, description='市净率百分比', )
    valuation_PTS_TTM = fields.FloatField(null=True, default=0, description='市销率TTM', )
    valuation_PTS_percentile = fields.FloatField(null=True, default=0, description='市销率百分位', )
    valuation_market_TTM = fields.FloatField(null=True, default=0, description='市现率TTM', )
    valuation_market_percentile = fields.FloatField(null=True, default=0, description='市现率百分比', )
    market_indicator = fields.FloatField(null=True, default=0, description='行情指标', )



    class Meta:
        table = with_table_name("wance_data_stock")