import asyncio
import json

from src.models import wance_data_stock
from src.tortoises_orm_config import init_tortoise


async def init_test():
    await init_tortoise()

    await wance_data_stock.WanceDataStock.create(
        stock_code='600051.SH',
        stock_name='宁波联合',
        stock_sector=['stockA'],  # 确保这是一个列表格式
        stock_type=['stock'],
        time_start='2010-01-01',
        time_end='20240911',
        time_expire='2024-09-11',
        market_sector='SH'
    )
    filters = {
        'stock_sector__contains': ["上证A股"]  # 列表形式用于 JSON 数组匹配
    }
    # filters = {
    #     'stock_sector__contains': ['stockA']  # 列表形式用于 JSON 数组匹配
    # }
    # stocks = await wance_data_stock.WanceDataStock.filter(stock_sector__contains=["上证A股"]).all()
    # stocks = await wance_data_stock.WanceDataStock.filter(stock_sector__contains=["上证A股", "沪深A股", "TGN共同富裕示范区", "TGN旅游概念", "TGN煤炭概念", "TGN物业管理", "TGN跨境电商", "THY1综合", "THY2综合", "THY3综合", "DY1浙江省", "DY2浙江省宁波市", "上证指数", "上证收益", "上证流通", "中型综指", "中证全指", "中证民企", "中证流通", "国证Ａ指", "新综指", "民企成长", "浙企综指", "浙江民企", "综合指数", "Ａ股指数", "GN共同富裕示范区", "GN婚庆", "GN小盘", "GN微盘股", "GN房地产", "GN批发业", "GN旅游", "GN浙江", "GN煤炭", "GN物业管理", "GN环杭州湾大湾区", "GN电力改革", "GN破净股", "GN舟山自贸区", "GN跨境电商", "GN进口博览会", "SW1综合", "SW1综合加权", "SW2综合", "SW2综合加权", "SW3综合", "SW3综合加权", "A股非科创等权", "上海A股等权", "上海主板等权", "上海全市场等权", "上证指数等权", "上证收益等权", "上证流通等权", "中型综指等权", "中证全指等权", "国证Ａ指等权", "新综指等权", "沪深全市场等权", "综合指数等权", "Ａ股指数等权", "CSRC1批发和零售业", "CSRC2批发业"]).all()
    # stocks = await wance_data_stock.WanceDataStock.filter(stock_sector__contains=["stock"]).all()
    stocks = await wance_data_stock.WanceDataStock.filter(**filters).all()


    print(stocks)


if __name__ == '__main__':
    asyncio.run(init_test())
