from tortoise import Tortoise
from tortoise.exceptions import OperationalError
from src.tortoises import TORTOISE_ORM
import asyncio


async def init_tortoise():
    """
    初始化 Tortoise-ORM 数据库连接
    """
    try:
        await Tortoise.init(config=TORTOISE_ORM)
        # print("Tortoise-ORM initialized successfully.")
    except OperationalError as e:
        print(f"OperationalError during initialization: {e}")
    except Exception as e:
        print(f"Error during initialization: {e}")


async def close_tortoise():
    """
    关闭 Tortoise-ORM 数据库连接
    """
    try:
        await Tortoise.close_connections()
        # print("Tortoise-ORM connections closed successfully.")
    except Exception as e:
        print(f"Error during closing connections: {e}")


