import sqlite3
from collections import deque

import redis.asyncio as aioredis
from fastapi import FastAPI

from src.settings.config import settings
from src.utils import redis


import akshare

from pypinyin import lazy_pinyin

from src.models import StockType
from src.models.stock import Stock, StockResponse
from src.utils.paginations import PaginationPydantic, pagination, Params



def register_redis(app: FastAPI):
    @app.on_event("startup")
    async def startup_redis():
        pool = aioredis.ConnectionPool.from_url(
            str(settings.REDIS_URL), max_connections=10, decode_responses=True
        )
        redis.redis_client = aioredis.Redis(connection_pool=pool)




    @app.on_event("shutdown")
    async def shutdown_redis():
        await redis.redis_client.connection_pool.disconnect()
        await redis.redis_client.shutdown()


