from datetime import datetime

import akshare
from pypinyin import lazy_pinyin

from src.models import StockType
from src.models.snowball import Snowball
from src.models.stock_details import StockDetails
from src.tortoises_orm_config import init_tortoise, close_tortoise


async def job():
    await init_tortoise()
    print(f"执行定时任务: 当前时间是 {datetime.now().strftime('%Y-%m-%d %H:%M:%S')}")

    await StockDetails.all().delete()
    stock_name_df = akshare.stock_sh_a_spot_em()
    stock_list = stock_name_df[['代码', '名称', '最新价', '涨跌幅']].values.tolist()

    for stock in stock_list:
        # 将文字转化为拼音列表
        pinyin_list = lazy_pinyin(stock[1])

        # 取每个拼音的首字母并连接成字符串
        initial_pinyin = ''.join([pinyin[0] for pinyin in pinyin_list])
        await StockDetails.create(stock_code=stock[0], stock_name=stock[1], type=StockType.SH,
                                  stock_pinyin=initial_pinyin, latest_price=stock[2], rise_fall=stock[3])
    stock_name_df = akshare.stock_sz_a_spot_em()
    stock_list = stock_name_df[['代码', '名称', '最新价', '涨跌幅']].values.tolist()

    for stock in stock_list:
        # 将文字转化为拼音列表
        pinyin_list = lazy_pinyin(stock[1])

        # 取每个拼音的首字母并连接成字符串
        initial_pinyin = ''.join([pinyin[0] for pinyin in pinyin_list])
        await StockDetails.create(stock_code=stock[0], stock_name=stock[1], type=StockType.SZ,
                                  stock_pinyin=initial_pinyin, latest_price=stock[2], rise_fall=stock[3])

    await close_tortoise()