"""

通用工具区域

"""


def split_stock_code(stock_code):
    """
    将股票代码按点（"."）切割成两部分。

    Args:
    stock_code (str): 原始股票代码（如 "000300.SH"）。

    Returns:
    tuple: 返回切割后的两部分（如 ('000300', 'SH')）。
    """
    return stock_code.split('.')


def join_stock_code(parts):
    """
    将切割后的股票代码部分按指定格式拼接。

    Args:
    parts (tuple): 切割后的股票代码部分（如 ('000300', 'SH')）。

    Returns:
    str: 返回拼接后的字符串（如 "SH000300"）。
    """
    part1, part2 = parts  # 解构切割后的结果
    return f"{part2}{part1}"


def percent_to_float(percent_string):
    if isinstance(percent_string, int):
        return float(percent_string)
    elif isinstance(percent_string, str):
        return float(percent_string.strip('%'))
    else:
        raise ValueError(f"Unsupported type: {type(percent_string)}")